Option Strict Off
Option Explicit On
Friend Class frmFolder
	Inherits System.Windows.Forms.Form
	
	Public sEmuFolder As String
	Public isTarget As Boolean
	
	Private Sub cmdCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCancel.Click
		sEmuFolder = ""
		Me.Close()
	End Sub
	
	'Set Special path on Dir Navigator
	Private Sub cmdDesktop_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDesktop.Click
		Dim Index As Short = cmdDesktop.GetIndex(eventSender)
		
		On Error GoTo ERR_SUB
		
		Drive1.Drive = Environ("SystemDrive")
		
		Select Case Index
			Case 0
				Dir1.Path = Environ("USERPROFILE") & "\Desktop"
			Case 1
				Dir1.Path = Environ("USERPROFILE") & "\Documents"
			Case 2
				Dir1.Path = Environ("USERPROFILE") & "\Downloads"
			Case 3
				Dir1.Path = Environ("USERPROFILE") & "\"
		End Select
		
		txtFilename.Text = Dir1.Path
		
		
EXIT_SUB: 
		Exit Sub
		
ERR_SUB: 
		MsgBox("SD FormLoad Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
		Resume EXIT_SUB
		
		
	End Sub
	
	Private Sub cmdOk_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdOk.Click
		sEmuFolder = txtFilename.Text
		Me.Close()
	End Sub
	
	Private Sub Dir1_Change(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Dir1.Change
		txtFilename.Text = Dir1.Path
	End Sub
	
	Private Sub Dir1_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Dir1.SelectedIndexChanged
		txtFilename.Text = Dir1.DirList(Dir1.DirListIndex)
	End Sub
	
	Private Sub Drive1_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Drive1.SelectedIndexChanged
		Dir1.Path = Drive1.Drive
	End Sub
	
	Private Sub frmFolder_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		
		On Error GoTo ERR_SUB
		
		If Trim(sEmuFolder) = "" Then
			
			
			If isTarget Then
				Drive1.Drive = My.Application.Info.DirectoryPath
				Dir1.Path = My.Application.Info.DirectoryPath
			Else
				Drive1.Drive = Environ("USERPROFILE")
				Dir1.Path = Environ("USERPROFILE") & "\Desktop"
			End If
		Else
			Drive1.Drive = sEmuFolder
			Dir1.Path = sEmuFolder
		End If
		
		
		sEmuFolder = Dir1.Path
		txtFilename.Text = Dir1.Path
		
EXIT_SUB: 
		Exit Sub
		
ERR_SUB: 
		MsgBox("SD FormLoad - You can go on but here there is an Unexpected Error n." & Err.Number & vbCrLf & Err.Description & vbCrLf & "Please report the error if you can")
		Resume EXIT_SUB
		
		
	End Sub
End Class