Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class frmSD
	Inherits System.Windows.Forms.Form
	
	Public oDrive As clsDrive
	Public isTarget As Boolean
	Public enTipo As basMain.enEmuType
	
	Private m_bLoadingForm As Boolean
	
	
	'UPGRADE_WARNING: L'evento cboDrives.TextChanged pu essere generato quando il form  inizializzato. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	'UPGRADE_WARNING: ComboBox evento cboDrives.Change  stato aggiornato a cboDrives.TextChanged che presenta un nuovo comportamento. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="DFCDE711-9694-47D7-9C50-45A99CD8E91E"'
	Private Sub cboDrives_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboDrives.TextChanged
		Dim oDrv As clsDrive
		
		'Select
		If Not g_cDrives Is Nothing Then
			
			For	Each oDrv In g_cDrives
				
				If oDrv.drvIndex = cboDrives.SelectedIndex Then
					oDrive = oDrv
					Exit For
				End If
				
			Next oDrv
			txtSector.Text = "0x" & CStr(Hex(oDrive.drvStartSector * 10000@))
			
		End If
	End Sub
	
	'UPGRADE_WARNING: L'evento cboDrives.SelectedIndexChanged pu essere generato quando il form  inizializzato. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cboDrives_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboDrives.SelectedIndexChanged
		Dim oDrv As clsDrive
		
		'Select
		If Not g_cDrives Is Nothing Then
			
            'For	Each oDrv In g_cDrives

            'If oDrv.drvIndex = cboDrives.SelectedIndex Then
            oDrive = cboDrives.SelectedItem ' oDrv
            'Exit For
            'End If

            'Next oDrv

            If Not isTarget Then

                txtSector.Text = "0x" & CStr(Hex(oDrive.drvStartSector * 10000@))
            End If

            If enTipo = basMain.enEmuType.enAtmHidden Then
                lstDrives.Visible = True
                FillList()
            Else
                lstDrives.Visible = False
                txtSector.Text = "0x2"
            End If

        End If
		
	End Sub
	
	'UPGRADE_WARNING: L'evento chkAllDrive.CheckStateChanged pu essere generato quando il form  inizializzato. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub chkAllDrive_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkAllDrive.CheckStateChanged
		
		If Not m_bLoadingForm Then
			
			On Error GoTo ERR_SUB
			
			If chkAllDrive.CheckState = System.Windows.Forms.CheckState.Checked Then
				If MsgBox(LangLabel("MSGShowAllDrives", "Are you sure you want to show all drive?" & vbCrLf & "Be very, very careful on what you are doing"), MsgBoxStyle.YesNo + MsgBoxStyle.Question, LangLabel("Warning", "Warning")) = MsgBoxResult.Yes Then
					g_bFindAllDrives = True
					cmdRefresh_Click(cmdRefresh, New System.EventArgs())
				End If
			Else
				g_bFindAllDrives = False
				cmdRefresh_Click(cmdRefresh, New System.EventArgs())
			End If
		End If
		
EXIT_SUB: 
		Exit Sub
		
ERR_SUB: 
		MsgBox("chkAllDrive Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
		Resume EXIT_SUB
		
	End Sub
	
	Private Sub cmdCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCancel.Click
		'UPGRADE_NOTE:  possibile che l'oggetto oDrive non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
		oDrive = Nothing
		Me.Close()
	End Sub
	
	Private Sub cmdOk_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdOk.Click
		
		Dim oDrv As clsDrive
		Dim sTmp As String
		
		On Error GoTo EXIT_SUB
		
		'Select
		If Not g_cDrives Is Nothing Then
			
            '			For	Each oDrv In g_cDrives

            '          If oDrv.drvIndex = cboDrives.SelectedIndex Then
            oDrive = cboDrives.SelectedItem ' oDrv
            'Exit For
            '           End If

            '			Next oDrv

            '        If oDrive.drvStartSector > 0 Then txtSector.Text = "0x" & CStr(Hex(oDrive.drvStartSector * 10000@))

        End If

        'Retrieve the text field value
        sTmp = Replace(txtSector.Text, "0x", "&h")
        If CDec(sTmp) > 0 Then
            oDrive.drvStartSector = CDec(sTmp) '/ 10000@
        End If

        '    If isTarget Then

        If (Trim(txtSector.Text) = "" Or Trim(txtSector.Text) = "0x") Then
            MsgBox(LangLabel("WriteSector", "Please Write sector number in Decimal or Hex writing the prefix 0x"), MsgBoxStyle.OkOnly, LangLabel("Missing", "Missing Sector number"))
        Else
            '           oDrive.drvStartSector = CCur(val(sTmp)) / 10000@
            Me.Close()
        End If
        '    Else
        '        Unload Me
        '    End If

EXIT_SUB:
        Exit Sub

ERR_SUB:
        MsgBox("cmdOKSD Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
        Resume EXIT_SUB
		
		
		
	End Sub
	
	Private Sub cmdRefresh_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRefresh.Click
		
		FindDrives()
		FillCombo()
		
	End Sub
	
	Private Sub frmSD_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        Dim iTmp As Integer

		On Error GoTo ERR_SUB
		
		m_bLoadingForm = True
		
		FindDrives()
		FillCombo()
		
		If cboDrives.Items.Count > 0 Then
            iTmp = cboDrives.SelectedIndex = 0
		End If
		
		'txtSector.Enabled = isTarget
		
		chkAllDrive.CheckState = IIf(g_bFindAllDrives, 1, 0)
		
		'txtSector.Enabled = True
		m_bLoadingForm = False
		
		
EXIT_SUB: 
		Exit Sub
		
ERR_SUB: 
		MsgBox("SD FormLoad Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
		Resume EXIT_SUB
		
		
	End Sub
	
	
	Private Sub FillCombo()
		
		Dim oDrv As clsDrive
		
		lstDrives.Items.Clear()
        cboDrives.Items.Clear()

        cboDrives.DisplayMember = "toString"

		If Not g_cDrives Is Nothing Then
			
			For	Each oDrv In g_cDrives
                cboDrives.Items.Add(oDrv)
				'UPGRADE_ISSUE: La propriet di ComboBox cboDrives.NewIndex non  stata aggiornata. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="F649E068-7137-45E5-AC20-4D80A3CC70AC"'
                'oDrv.drvIndex = cboDrives.NewIndex
			Next oDrv
			
		End If
	End Sub
	
	
	'Procedures
	Private Sub FillList()
		
		Dim prt As clsPartition
		
		lstDrives.Items.Clear()
		
		If Not oDrive Is Nothing Then
			
			For	Each prt In oDrive.Partitions
				lstDrives.Items.Add(Trim(Split(Replace(prt.Name, "#", ""), ",")(1)) & " - " & VB6.Format(CStr((prt.Size * 10000) / (CInt(1024) * CInt(1024))), "#,### MByte ") & "(0x" & CStr(Hex(prt.StartingAddress / 512)) & ")")
			Next prt
			
		End If
		
	End Sub
	
	'UPGRADE_WARNING: L'evento lstDrives.SelectedIndexChanged pu essere generato quando il form  inizializzato. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub lstDrives_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles lstDrives.SelectedIndexChanged
		
		Dim tmp As String
		'UPGRADE_NOTE: val  stato aggiornato a val_Renamed. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
		Dim val_Renamed As Decimal
		
		tmp = Split(lstDrives.Text, "(")(1)
		tmp = VB.Left(tmp, Len(tmp) - 1)
		tmp = Replace(tmp, "0x", "&h")
		val_Renamed = CDec(tmp)
		val_Renamed = val_Renamed + 32768@
		txtSector.Text = "0x" & Hex(val_Renamed)
		
		
	End Sub
End Class